/*
 * AVR based RGB Moodlight
 *
 * moodlight.h - moodlight modes and remote control, prototypes
 *
 * (c) Axel (XL) Schwenke, axel.schwenke@gmx.net
 *
 * $Id: moodlight.h 149 2012-02-14 20:19:45Z schwenke $
 
 
  Version3 soll auf dem AT90S4433 portiert werden. Hierzu bentigt die Schaltung noch einen Quarz 8 MHz und zwei Kondensatoren 33 pF.
 */

#ifndef _MOODLIGHT_chr5_H_
#define _MOODLIGHT_chr5_H_

#define MAX_BRIGHT 204			//mu immer konstant 204 sein, weil die Tabelle genau diese Gre hat
//#define MAX_BRIGHT 20			//schlecht
//#define MAX_BRIGHT 255		//auch schlecht
//#define MAX_BRIGHT 80

extern uint8_t level_r;
extern uint8_t level_g;
extern uint8_t level_b;
extern volatile uint8_t tick;
//extern IRMP_DATA irmp_data;		///<<<----------------------------<<<<<<<<<<<------------------

extern volatile uint8_t tick_timer0; 	//fr timer0-Interrupt fr DS18S20 Temperaturmessung
extern volatile uint8_t second;			//fr DS18S20 Temperaturmessung



volatile uint16_t	i;					//fr RC5-Decoder
char s[11];								//global definiert
uint16_t zaehlvariable;					//global definiert, 

void moodlight_remote(void);
void moodlight_init(void);
void moodlight_wakeup(void);
void moodlight_step(void);

void read_meas_lcd();
void start_meas();						//das erste der beiden Unterprogramme in TEMPMEAS.c
void read_meas();						//das zweite 
void uinit();							//fr Temperaturmessung
void uputsnl();

#endif


#ifndef _main_h_
#define _main_h_
#include <avr/io.h>
#include <avr/interrupt.h>
//#include <avr/signal.h>
//#include <avr/signal.h>
#include <stdlib.h>
#include <stdio.h>
#include <avr/pgmspace.h>		//zum Eintragen des Textes, der die Programmversion anzeigt in der hex-Datei.
#include <util/delay.h>

//Auswahl des verwendeten Mikrocontroller-Typs
//#define Mega168			//passt auch fr Mega48 und Mega88
//#define Mega8
#define AT90S4433

//#define XTAL		8000000L
#define XTAL		4000000L


//Teil aus "MAIN_chr1.H" aus dem Temperatur-Me-Programm
//#define XTAL		8000000L

#define	BAUD	19200
//#define	BAUD	9600

#define bauddivider (uint)(1.0 * XTAL / BAUD / 16 - 0.5)


#define uchar unsigned char
#define uint unsigned int
#define bit uchar
#define idata
#define code


#define W1_PIN	PD4		//am Mega8 Pin6 = PD4, dort ist der Sensor angeschlossen
#define W1_IN	PIND
#define W1_OUT	PORTD
#define W1_DDR	DDRD

/*
#include "1wire_chr1.h"
//#include "delay_chr1.h"
#include "tempmeas_chr1.h"
//#include "timebase_chr1.h"
*/
#include "uart_chr1.h"

#define use_uart

#endif

//Ende
