/************************************************************************/
/*                                                                      */
/*                      RC5 Remote Receiver                             */
/*                                                                      */
/*              Author: Peter Dannegger                                 */
/*                      danni@specs.de                                  */
/*                                                                      */
/************************************************************************/
//#include "blink_led.h"
#include "RC5_3.h"
//#include <util/delay.h>
//#include <io.h>
//#include <interrupt.h>
//#include <signal.h>
//#include <stdlib.h>

#define RC5TIME 	1.778e-3		// 1.778msec
#define PULSE_MIN	(uchar)(XTAL / 512 * RC5TIME * 0.4 + 0.5)
#define PULSE_1_2	(uchar)(XTAL / 512 * RC5TIME * 0.8 + 0.5)
#define PULSE_MAX	(uchar)(XTAL / 512 * RC5TIME * 1.2 + 0.5)

/*
//Macro Definitionen zum Einlesen der Zustnde an den Pins wo der Drehencoder angeschlossen ist.
#define PHASE_A	(PINB & 1<<PINB0)	// PINB.0
#define PHASE_B (PINB & 1<<PINB1)	// PINB.1
*/

uchar	rc5_bit;				// bit value
uchar	rc5_time;				// count bit time
uint	rc5_tmp;				// shift bits in
volatile uint	rc5_data;				// store result
extern volatile uint16_t	i;	//fr RC5-Decoder
extern volatile uint16_t DS18S20_zeitgeber;		//RC5-Interrupt soll ber Zhlvariable eine lngere Verzgerung ermglichen z.B. 0,7 s

//volatile char	enc_delta;		// -128 ... 127		//fr Drehencoder


ISR (TIMER0_OVF_vect)	//Timer/Counter0 Overflow an Mega48 und At90S4433 angepasst. Wenn z.B. vom AT90S2313 der Name drin steht, gibt es keine Fehlermeldung, aber das Programm hngt sich auf.
{

//  static char enc_last = 0x01;		//fr Drehencoder
//  char j = 0;						//fr Drehencoder


  uint tmp = rc5_tmp;				// for faster access

  TCNT0 = -2;					// 2 * 256 = 512 cycle
  
  DS18S20_zeitgeber++;
  
//  		PORTB ^= (1 << PB1);    // LED toggeln PB1
//				 _delay_ms( 25 );

  if( ++rc5_time > PULSE_MAX ){			// count pulse time
    if( !(tmp & 0x4000) && tmp & 0x2000 )	// only if 14 bits received
      rc5_data = tmp;
    tmp = 0;
  }

  if( (rc5_bit ^ xRC5_IN) & 1<<xRC5 ){		// change detect
    rc5_bit = ~rc5_bit;				// 0x00 -> 0xFF -> 0x00

    if( rc5_time < PULSE_MIN )			// to short
      tmp = 0;

    if( !tmp || rc5_time > PULSE_1_2 ){		// start or long pulse time
      if( !(tmp & 0x4000) )			// not to many bits
        tmp <<= 1;				// shift
      if( !(rc5_bit & 1<<xRC5) )		// inverted bit
        tmp |= 1;				// insert new bit
      rc5_time = 0;				// count next pulse time
    }
  }

  rc5_tmp = tmp;
/*  
//ab hier Drehencoder auswerten  
    if( PHASE_A )
    j = 1;

	if( PHASE_B )
    j ^= 3;				// convert gray to binary

	j -= enc_last;			// difference new - last

	if( j & 1 ){				// bit 0 = value (1)
    enc_last += i;			// store new as next last

    enc_delta += (j & 2) - 1;		// bit 1 = direction (+/-)
  }
//Ende Drehencoder auswerten  
*/  
//PORTB ^= (1 << PB1);    // LED toggeln PB1 = OC1A PWM-Ausgang	-->>OK, geht
}



void RC5_Empfang (void)
	{
	
	cli();
    i = rc5_data;			// read two bytes from interrupt !
    rc5_data = 0;
    sei();
    if( i )
		{
	
		lcd_setcursor( 0, 1 );		//Spalte 0, Zeile1

		uputs( "\n\r" );
		uputchar	(( i >> 11 & 1) + '0');	// Toggle Bit
//		lcd_data	(( i >> 11 & 1) + '0' );
	  
		uputchar(' ');
//		lcd_data( ' ');
	  
		itoa( i >> 6 & 0x1F, s, 10);	// Device address
      
		uputs( s );
//		lcd_string( s );
	  
		uputchar(' ');
//		lcd_data(' ');
	  
		itoa((i & 0x3F) | (~i >> 7 & 0x40), s, 10); // Key Code   s ist ein character-array mit 30 Zeichen
		uputs( s );		// Ausgabe des Array-Inhaltes an das UART
//		lcd_string( s );

	  


//		if (ml.flags == ML_FLAG_OFF)	uputs( " OFF \n\r" );		//OK, erzeugt ausgabe, falls das Flag gesetzt ist
	  
		uputs( "\n\r" );
//		lcd_clear();

		PORTB ^= (1 << PB1);   	// LED toggeln PB1 = OC1A PWM-Ausgang


//		i = 0;		//nach einmaligen durchlauf soll i im Hauptprogramm oder wenn RC5-Empfang nochmals ohne empfang aufgerufen wird, nicht nochmals auslsen.
		//ohne diese Zeile geht die Geschwindigkeitsregelung nur aprupt von Min nach Max.
		//mit dieser Zeile geht die Umschaltung der Betriebsart ml.mode gar nicht mehr.
		//hier ist die falsche Stelle. Es darf nur gelscht werden, nachdem ein Zeichen empfangen wurde.
		}								//Ende if (i)

	
	
	}


/*
SIGNAL (SIG_OVERFLOW0)
{
  static char enc_last = 0x01;
  char j = 0;

  if( PHASE_A )
    j = 1;

  if( PHASE_B )
    j ^= 3;				// convert gray to binary

  j -= enc_last;			// difference new - last

  if( j & 1 ){				// bit 0 = value (1)
    enc_last += j;			// store new as next last

    enc_delta += (j & 2) - 1;		// bit 1 = direction (+/-)
  }
}
*/

